<!-- Component to create a task -->
<template>
  <b-card bg-variant="light">
    <form @submit="onSubmit">
      <b-form-group
        label-cols-lg="3"
        label="Ajout d'une tâche"
        label-class="my-custom-font"
        class="mb-0"
      >
        <b-row>
          <b-col
            lg="5"
            md="5"
            sm="12"
          >
            <b-form-group
              label="Titre"
              label-for="title"
              label-cols-sm="3"
              label-align-sm="right"
              invalid-feedback="Champ obligatoire"
              :state="stateTitle"
            >
              <b-form-input
                id="title"
                v-model="title"
                :state="stateTitle"
              />
            </b-form-group>
          </b-col>
          <b-col
            lg="5"
            md="5"
            sm="12"
          >
            <b-form-group
              label="Description"
              label-for="body"
              label-cols-sm="4"
              label-align-sm="left"
              invalid-feedback="Champ obligatoire"
              :state="stateDescription"
            >
              <b-form-textarea
                id="body"
                v-model="body"
                placeholder="Description"
                rows="3"
                max-rows="6"
                :state="stateDescription"
              />
            </b-form-group>
          </b-col>
          <b-col
            lg="2"
            md="2"
            sm="12"
          >
            <b-button
              type="submit"
              variant="success"
              style="margin-top: 38px;"
            >
              <i class="fas fa-plus" /> Ajouter
            </b-button>
          </b-col>
        </b-row>
      </b-form-group>
    </form>
  </b-card>
</template>

<script>
export default {
  name: 'CreateTodo',
  data () {
    return {
      title: '',
      body: ''
    }
  },
  computed: {
    /**
     * To validate if title is not empty
     * @return {boolean}
     */
    stateTitle () {
      return this.title !== ''
    },
    /**
     * To validate if description is not empty
     * @return {boolean}
     */
    stateDescription () {
      return this.body !== ''
    }
  },
  methods: {
    /**
     * Sends an event to the parent component to tell it to encircle the process of creating a task
     * @param event {Event}
     */
    onSubmit (event) {
      event.preventDefault()
      if (this.title !== '' && this.body !== '') {
        this.$emit('createtodoevent', {
          title: this.title,
          body: this.body
        })
        this.reset()
      } else {
        alert('invalid')
      }
    },
    /**
     * Resets the form
     */
    reset () {
      this.title = ''
      this.body = ''
    }
  }
}
</script>

<style>
.my-custom-font {
  font-weight: bolder;
  font-size: 18px;
}
</style>
